
#include "FairyUART.h"
#include "define.h"
#include "CRC16.h"
#include <stdio.h>


UARTStruct	UARTStr;

void FairyUARTInit()
{
	SYS_UnlockReg();
	UART_Open(UART,FairyBaudRate);
	FairyUARTIOSet();
	UART_SetTimeoutCnt(UART,3.5*10);
	NVIC_EnableIRQ(UART_IRQn);
	UART->FCR |=0xF<<4;			//14bitж
	UART_ENABLE_INT(UART, UART_IER_RDA_IEN_Msk|UART_IER_RTO_IEN_Msk|UART_IER_TIME_OUT_EN_Msk);	//ʹܳʱж(RTO_IEN);ʱ(TIME_OUT_EN);ж(RDA_IEN)
	SYS_LockReg();
#ifdef DebugUART
	printf("UART_Test!\n");
#endif
}

void UART_IRQHandler()
{
	if(UART_GET_INT_FLAG(UART, UART_ISR_TOUT_INT_Msk|UART_ISR_TOUT_IF_Msk))	UARTTimeOutCallBack();
	else if(UART_GET_INT_FLAG(UART, UART_ISR_RDA_IF_Msk))	UARTRDACallBack();
	else if(UART_GET_INT_FLAG(UART, UART_ISR_THRE_INT_Msk))	UARTTxIntCallBack();
}

void UARTTxIntCallBack()
{
	while(!UART_IS_TX_FULL(UART))
	{
		UART_WRITE(UART,UARTStr.TxBuff[UARTStr.TxIndex++]);
		if(UARTStr.TxIndex>=UARTStr.TxWaitNum) 
		{
			UARTStr.TxIndex=0;
			UARTStr.TxWaitNum=0;
			UART_DISABLE_INT(UART,UART_IER_THRE_IEN_Msk);	//ʧܷͱּĴж
			EnableRxRead();
			break;
		}		
	}
}
void UARTRDACallBack()
{
	while(!UART_GET_RX_EMPTY(UART))
	{
		if(UARTStr.RxIndex>=RxBuffLen) UARTStr.RxIndex=RxBuffLen-1;	//ݳ,ԶĨĩλ
		UARTStr.RxBuff[UARTStr.RxIndex++]=UART_READ(UART);			
	}	//ݵ14bitж
}
void UARTTimeOutCallBack()
{
	Uint8 i;
	while(!UART_GET_RX_EMPTY(UART))
	{
		if(UARTStr.RxIndex>=RxBuffLen) UARTStr.RxIndex=RxBuffLen-1;	//ݳ,ԶĨĩλ
		UARTStr.RxBuff[UARTStr.RxIndex++]=UART_READ(UART);			//ݱʱж
	}
	if(CheckCRC16()==True)
	{
		DisableRxRead();	//ݻû,ֹ,δ,Ͳж,ͲˢRx洢
		for(i=0;i<RxBuffLen;i++)
		{
			UARTStr.Rx[i]=0;
		}
		UARTStr.RxIndex-=2;		//CRCHiCRCLoλ
		for(i=0;i<UARTStr.RxIndex;i++)
		{
			UARTStr.Rx[i]=UARTStr.RxBuff[i];
		}
	}
	UART_ClearIntFlag(UART,UART_ISR_TOUT_INT_Msk);			//ʱж
	UARTStr.RxIndex=0;
}

Boolen CheckCRC16()
{
	Uint16 LastWords,CRCWords;
	LastWords=((Uint16)(UARTStr.RxBuff[UARTStr.RxIndex-1]<<8)|(Uint16)UARTStr.RxBuff[UARTStr.RxIndex-2]);
	CRCWords=CRC16(UARTStr.RxBuff, UARTStr.RxIndex-2);
	if(LastWords==CRCWords)	return True;
	else 
#ifdef DebugCRC
	printf("CRC Check is Fail!\n");
	printf("CRCWords is %x\n",CRCWords);
	printf("LastWords is %x\n",LastWords);
#endif
	return False;
}

Boolen FairyTxData(Uint8 *pDataAddress,Uint8 DataLen)
{
	Uint8 i=0;
	Uint16 temp;
	if(DataLen)
	{
		temp=CRC16(pDataAddress,DataLen);
		while(UARTStr.TxWaitNum);
		if(DataLen<=TxBuffLen-2)
		{
			while(DataLen--)
			{
				UARTStr.TxBuff[i++]=*pDataAddress++;
			}
			UARTStr.TxBuff[i++]=(Uint8)(temp&0xFF);
			UARTStr.TxBuff[i++]=(Uint8)(temp>>8);
			UARTStr.TxWaitNum=i;
			UART_ENABLE_INT(UART,UART_IER_THRE_IEN_Msk);	//ʹܷͱּĴж
			return True;
		}
		else	return False;
	}
	else return False;
}
			
void ClearRxBuff(void)	
{
	Uint8 i;
	for(i=0;i<RxBuffLen;i++)
	{
		UARTStr.Rx[i]=0;
	}
}	

/******************** (C) COPYRIGHT 2014 Hwyton Electric Corp. *************************/

