
#include "FairyCLK.h"
#include "FairyUART.h"
#include "FairyIO.h"
#include "define.h"
#include "RTL.h"
#include <stdio.h>

class Task
{
	private:
		OS_TID 	ID;
		Uint8	Pra;
	public:
		Task(OS_TID x)
		{
			ID=x;
		}
		inline 	void	Create(void(*fuction)(void), Uint8 PraSet);
		inline 	void 	Delete(void);
		inline 	void	Wait(Uint16 Cycle);
		virtual __task 	void 	Function(void);
};	


inline void Task::Wait(Uint16 Cycle)
{
	os_dly_wait(Cycle);
}


inline void Task::Delete()
{
	printf("%d Task is delete\n",ID);
	os_tsk_delete(ID);	
}


inline void Task::Create(void(*fuction)(void),Uint8 PraSet)
{
	Pra=PraSet;
	ID=os_tsk_create(fuction,PraSet);
}


__task  void TaskBFunction(void);
__task	void TaskAFunction(void);


__task  void TaskBFunction(void)
{
	extern Task TaskB;
	while(1)
	{
		GreenLED=~GreenLED;
		TaskB.Wait(50);
	}
}


__task	void TaskAFunction(void)
{
	while(1)
	{
		Task TaskA(os_tsk_self());
		Task TaskB(os_tsk_create(TaskBFunction,0));
		TaskA.Delete();
		TaskA.~Task();
	}
}


int main()
{
	FairyCLKInit();
	FairyUARTInit();
	FairyIOInit();
	os_sys_init(TaskAFunction);	
	for(;;);
}

