


#ifdef __cplusplus
extern "C"
{
#endif
#ifndef _FairyUART_H
	#define _FairyUART_H

#include "Mini51Series.h"
#include "GPIO.h"
#include "UART.h"
#include "SYS.h"
#include "define.h"

#define FairyBaudRate 9600
#define RxBuffLen	30
#define TxBuffLen	RxBuffLen
typedef struct
{
		Uint8 	RxBuff[RxBuffLen];
	volatile	Uint8 	RxIndex;
	volatile	Uint8	Rx[RxBuffLen];
	volatile	Uint8 	TxBuff[TxBuffLen];
		Uint8	TxIndex;
	volatile	Uint8	TxWaitNum;
}UARTStruct;

#define DisableRxRead()		UART_DISABLE_INT(UART, UART_IER_RTO_IEN_Msk|UART_IER_RDA_IEN_Msk)
#define EnableRxRead()		UART_ENABLE_INT(UART, UART_IER_RTO_IEN_Msk|UART_IER_RDA_IEN_Msk)
#define FairyUARTIOSet()	SYS->P0_MFP&=~(SYS_MFP_P00_Msk|SYS_MFP_P01_Msk); SYS->P0_MFP|=(SYS_MFP_P00_TXD|SYS_MFP_P01_RXD) 


void ClearRxBuff(void);			
void FairyUARTInit(void);
void UARTTimeOutCallBack(void);
Boolen CheckCRC16(void);
void UARTRDACallBack(void);
void UARTTxIntCallBack(void);
Boolen FairyTxData(Uint8 *pDataAddress,Uint8 DataLen);


#endif

#ifdef __cplusplus
}
#endif


